using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public abstract class Ability : MonoBehaviour
{
    protected GameManager gameManager;
    protected Rigidbody castRigid;
    protected Transform castTransform;
    protected CasterType casterType;

    protected Rigidbody rigid;

    protected virtual void Start()
    {
        rigid = GetComponent<Rigidbody>();
        StartCoroutine(LifetimeDestroy());
    }

    protected virtual void Update()
    {

    }

    public virtual void Initialize(GameManager gameManager, Rigidbody castRigid, Transform castTransform, CasterType casterType)
    {
        this.gameManager = gameManager;
        this.castRigid = castRigid;
        this.castTransform = castTransform;
        this.casterType = casterType;
    }

    protected virtual IEnumerator LifetimeDestroy()
    {
        Destroy(gameObject);
        yield break;
    }
}
