using System.Collections;
using System.Collections.Generic;
using UnityEngine;

[RequireComponent(typeof(EnemyAI))]
public class Enemy : Character
{
    public int minEssenceDrop = 3;
    public int maxEssenceDrop = 20;

    bool createdEssence = false;

    protected override void Die()
    {
        isDead = true;
        gameManager.GetComponent<EnemySpawnManager>().RemoveEnemy(this);

        CreateEssence();

        Destroy(gameObject);
    }

    private void CreateEssence()
    {
        if (createdEssence) return;

        for (int i = 0; i < Random.Range(minEssenceDrop, maxEssenceDrop + 1); i++)
        {
            Essence essence = Instantiate(gameManager.essencePrefab, transform.position, Quaternion.identity).GetComponent<Essence>();
            essence.Setup(gameManager.Player.transform, 4f);
        }

        createdEssence = true;
    }
}
