using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Essence : MonoBehaviour
{
    public float speed = 2f;
    public float acceleration = 5f;
    public bool canGive = true;

    private float variance = 0f;

    private Transform target;
    private Vector3 halfwayPoint;
    private bool reachedHalfway;
    private Rigidbody rigid;

    public Transform Target => target;

    public void Setup(Transform target, float variance = 0f)
    {
        this.target = target;
        this.variance = variance;
    }

    void Start()
    {
        rigid = GetComponent<Rigidbody>();
        halfwayPoint = transform.position + ((target.position - transform.position) * 0.5f);
        halfwayPoint += new Vector3(Random.Range(-variance, variance), Random.Range(-variance, variance), Random.Range(-variance, variance));
    }

    // Update is called once per frame
    void Update()
    {
        if(reachedHalfway || variance == 0f)
        {
            rigid.velocity = (target.position - transform.position).normalized * speed * Time.deltaTime;
        }
        else
        {
            rigid.velocity = (halfwayPoint - transform.position).normalized * speed * Time.deltaTime;
            if (Vector3.Distance(transform.position, halfwayPoint) <= 2f) reachedHalfway = true;
        }
        speed += acceleration * Time.deltaTime;
    }
}
