using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Tome : MonoBehaviour
{
    public float collectionRadius = 3f;

    private GameManager gameManager;

    // Start is called before the first frame update
    void Awake()
    {
        gameManager = FindObjectOfType<GameManager>();
    }

    // Update is called once per frame
    void Update()
    {
        WinHandler();
    }

    private void WinHandler()
    {
        if (gameManager.Player == null) return;

        if (Vector3.Distance(gameManager.Player.transform.position, transform.position) <= collectionRadius)
        {
            gameManager.Win();
        }
    }


    void OnDrawGizmos()
    {
        Gizmos.color = Color.red * 0.25f;
        Gizmos.DrawSphere(transform.position, collectionRadius);
    }
}
